const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of drugCategories by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} drugCategories - The array of drugCategories to format.
 * @returns {Promise<Object[]>} - The formatted array of drugCategories.
 */
const formatWithModifier = async (drugCategories) => {
    return Promise.all(
        drugCategories.map(async (drugCategory) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: drugCategory.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...drugCategory,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all drugCategories with their parent drugCategory title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.drugCategoriesId - The ids of the drugCategories to retrieve.
 * @returns {Promise<Object>} - The response object with the drugCategories and success status.
 */
async function getAll(params) {
    try {
        // filter
        const filterConditions = {};

        let drugCategories = []
        drugCategories = await dbSAPPS.DrugCategory.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
        });

        drugCategories = drugCategories.map(drugCategory => {
            return {
                ...drugCategory.dataValues
            }
        });

        drugCategories = await formatWithModifier(drugCategories);

        return {
            drugCategories,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get drugCategory items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the drugCategory items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the drugCategory items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the drugCategory items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        let options = [];
        options = await dbSAPPS.DrugCategory.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']]
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active drugCategory items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.DrugCategory.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new drugCategory item.
 * 
 * @param {Object} params - The new drugCategory item data.
 * @param {string} params.name - The name of the drugCategory item.
 * @param {string} params.title - The title of the drugCategory item.
 * @param {number} [params.parent_id] - The ID of the parent drugCategory item.
 * @param {string} [params.url] - The URL of the drugCategory item.
 * @param {string} [params.icon] - The icon of the drugCategory item.
 * @param {string} [params.type=link] - The type of the drugCategory item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the drugCategory item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the drugCategory item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the drugCategory item.
 * @param {number} [params.owner=1] - The ID of the user who created the drugCategory item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the drugCategory item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the drugCategory item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.DrugCategory.findOne({
            where: { display_name: params.display_name },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.DrugCategory.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing drugCategory item.
 * 
 * @param {number} id - The ID of the drugCategory item to update.
 * @param {Object} params - The updated drugCategory item data.
 * @param {string} [params.name] - The new name of the drugCategory item.
 * @param {string} [params.title] - The new title of the drugCategory item.
 * @param {number} [params.parent_id] - The new parent ID of the drugCategory item.
 * @param {string} [params.url] - The new URL of the drugCategory item.
 * @param {string} [params.icon] - The new icon of the drugCategory item.
 * @param {string} [params.type] - The new type of the drugCategory item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the drugCategory item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the drugCategory item.
 * @param {number} [params.modified] - The new last modification timestamp of the drugCategory item.
 * @param {number} [params.owner] - The new ID of the user who created the drugCategory item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the drugCategory item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the drugCategory item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const drugCategory = await dbSAPPS.DrugCategory.findByPk(id);
        if (!drugCategory) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.DrugCategory.findOne({
            where: {
                display_name: params.display_name,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await drugCategory.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a drugCategory
 * @param {number} id - the id of the drugCategory
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const drugCategory = await dbSAPPS.DrugCategory.findByPk(id);
        if (!drugCategory) return { success: false, message: 'ID not found!' };

        // delete
        await drugCategory.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

